ListKong/Controllers/CompanyUserController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    public class CompanyUserController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;
        private readonly UserManager<ApplicationUser> _userManager;

        public CompanyUserController(IConfiguration configuration, UserManager<ApplicationUser> userManager)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
            this._userManager = userManager;
        }
        #endregion
        public IActionResult Index()
        {
            string companyName = HttpContext.Session.GetString("_CompanyName");
            if (string.IsNullOrEmpty(companyName))
            {
                return RedirectToAction("Index", "Company");
            }
            DataTable _dtResponseP = CompanyUserListByUserId();
            if (this._objHelper.checkDBNullResponse(_dtResponseP))
            {
                List<CompanyUserListModel> lst = new List<CompanyUserListModel>();
                lst = ExtensionMethods.DataTableToList<CompanyUserListModel>(_dtResponseP);
                return View(lst);
            }

            return View();
        }
        public IActionResult CreateUser()
        {
            var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            CompanyUserModel model = new CompanyUserModel();
            ViewData["Roles"] = RoleList();
            ViewData["CompanyName"] = HttpContext.Session.GetString("_CompanyName");
            var companyId= HttpContext.Session.GetString("_CompanyId");
            ViewData["Locations"] = LocationList();
            model.CompanyId = Convert.ToInt64(companyId);
            model.CompanyName = Convert.ToString(ViewData["CompanyName"]);
            //ViewData["CompanyByAdminUser"] = CompanyList();
            return View(model);
        }
        [HttpPost]
        public IActionResult CreateUser(CompanyUserModel model)
        {
            if (!ModelState.IsValid)
            {
                var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                ViewData["Roles"] = RoleList();
                ViewData["CompanyName"] = HttpContext.Session.GetString("_CompanyName");
                var companyId = HttpContext.Session.GetString("_CompanyId");
                model.CompanyId = Convert.ToInt64(companyId);
                model.CompanyName = Convert.ToString(ViewData["CompanyName"]);
                ViewData["Locations"] = LocationList();
                return View(model);
            }
            var user = new ApplicationUser { UserName = model.Email, Email = model.Email, FirstName = model.FirstName, LastName = model.LastName };
            var result = _userManager.CreateAsync(user, model.Password).Result;
            if (result.Succeeded)
            {
                //bool adminRoleExists = _userManager.
                var role = _userManager.AddToRoleAsync(user, model.RoleName).Result;
                var currentUser = _userManager.FindByNameAsync(user.UserName).Result;
                var output = AddUserInCompany(currentUser.Id.ToString(), model.CompanyId,Convert.ToInt64(model.LocationId));
                TempData["SuccessMessage"] = "Company user successfully added!";
                return RedirectToAction("Index");
            }
            else
            {
                ViewData["Roles"] = RoleList();
                ViewData["CompanyName"] = HttpContext.Session.GetString("_CompanyName");
                var companyId = HttpContext.Session.GetString("_CompanyId");
                model.CompanyId = Convert.ToInt64(companyId);
                model.CompanyName = Convert.ToString(ViewData["CompanyName"]);
                ViewData["Locations"] = LocationList();
                TempData["ErrorMessage"] = result.Errors.FirstOrDefault().Description;
                return View(model);
            }
        }
        public IActionResult Edit(string Id)
        {
            EditCompanyUserModel model = new EditCompanyUserModel();
            ViewData["Roles"] = RoleList();
            ViewData["CompanyName"] = HttpContext.Session.GetString("_CompanyName");
            var companyId = HttpContext.Session.GetString("_CompanyId");
            model.CompanyId = Convert.ToInt64(companyId);
            model.CompanyName = Convert.ToString(ViewData["CompanyName"]);
            ViewData["Locations"] = LocationList();
            DataTable _dtResponseP = CompanyUserDetailById(Id);
            if (this._objHelper.checkDBNullResponse(_dtResponseP))
            {
                List<EditCompanyUserModel> lst = new List<EditCompanyUserModel>();
                lst = ExtensionMethods.DataTableToList<EditCompanyUserModel>(_dtResponseP);
                return View(lst.FirstOrDefault());
            }
            return View(model);
        }
        [HttpPost]
        public IActionResult Edit(EditCompanyUserModel model)
        {
            try
            {
                if (!ModelState.IsValid)
                {
                    ViewData["Roles"] = RoleList();
                    ViewData["CompanyName"] = HttpContext.Session.GetString("_CompanyName");
                    var companyId = HttpContext.Session.GetString("_CompanyId");
                    model.CompanyId = Convert.ToInt64(companyId);
                    model.CompanyName = Convert.ToString(ViewData["CompanyName"]);
                    ViewData["Locations"] = LocationList();
                    return View(model);
                }
                ViewData["Roles"] = RoleList();
                ViewData["CompanyByAdminUser"] = CompanyList();

                var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@Id", model.Id));
                parameters.Add(new KeyValuePair<string, string>("@FirstName", model.FirstName));
                parameters.Add(new KeyValuePair<string, string>("@LastName", model.LastName));
                parameters.Add(new KeyValuePair<string, string>("@Email", model.Email));
                parameters.Add(new KeyValuePair<string, string>("@RoleName", model.RoleName));
                parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(model.CompanyId)));
                parameters.Add(new KeyValuePair<string, string>("@LocationId", Convert.ToString(model.LocationId)));
                parameters.Add(new KeyValuePair<string, string>("@UpdatedBy", Convert.ToString(loggedInUserId)));
                DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_User_Detail_Created_By_Admin", parameters);
                TempData["SuccessMessage"] = "User successfully Updated!";
                return RedirectToAction("Index");
            }
            catch (Exception ex)
            {
                TempData["ErrorMessage"] = ex.Message.ToString();
                return RedirectToAction("Index");
            }
        }
        public async Task<IActionResult> Delete(string Id)
        {
            EditCompanyUserModel model = new EditCompanyUserModel();
            try
            {
                DataTable _dtResponseP = DeleteUser(Id);
                if (this._objHelper.checkDBNullResponse(_dtResponseP))
                {
                    if (Convert.ToString(_dtResponseP.Rows[0]["Result"]) == "1")
                    {
                        TempData["SuccessMessage"] = "User successfully Deleted!";
                        return RedirectToAction("Index");
                    }
                    else
                    {
                        TempData["ErrorMessage"] = "There is some error. Please try later!";
                        return RedirectToAction("Index");
                    }
                }
                return View(model);
            }
            catch (Exception ex)
            {
                TempData["ErrorMessage"] = ex.Message.ToString();
                return RedirectToAction("Index");
            }
        }
        private int AddUserInCompany(string userId, Int64 CompanyId,Int64 LocationId)
        {
            var loggedInUserId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@UserId", userId));
            parameters.Add(new KeyValuePair<string, string>("@CompanyId", Convert.ToString(CompanyId)));
            parameters.Add(new KeyValuePair<string, string>("@LocationId", Convert.ToString(LocationId)));
            parameters.Add(new KeyValuePair<string, string>("@CreatedBy", Convert.ToString(loggedInUserId)));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Add_New_Company_User", parameters);
            return 1;
        }

ListKong/Views/CompanyUser/CreateUser.cshtml
@model ListKong.Models.CompanyUserModel
@using  System.Data;
@{
    ViewData["Title"] = "Company User";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">

        <ol class="breadcrumb">
            <li><a asp-controller="CompanyUser" asp-action="Index"><i class="fa fa-dashboard"></i><span class="icon-after-span">Manage Company User</span></a></li>
            <li class="active">Add Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="box-title">Add Company User</h4>
                </div>
                @if (!string.IsNullOrEmpty(Convert.ToString(TempData["ErrorMessage"])))
                {
                    <div class="alert alert-danger">  @TempData["ErrorMessage"]</div>
                    <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                    </script>
                }
                @if (!string.IsNullOrEmpty(Convert.ToString(TempData["SuccessMessage"])))
                {
                    <div class="alert alert-success">  @TempData["SuccessMessage"]</div>
                    <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                    </script>
                }
                <form asp-action="CreateUser" enctype="multipart/form-data" method="post">
                    <div class="panel-body table-responsive">
                        <div class="col-md-6">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>
                            <div class="form-group">
                                <input type="hidden" asp-for="CompanyId" class="form-control" />
                                <label asp-for="CompanyName" class="control-label"></label>
                                <input asp-for="CompanyName" class="form-control" style="pointer-events:none;" />
                                <span asp-validation-for="CompanyName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LocationId" class="control-label"></label>
                                <select asp-for="LocationId" id="LocationId" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt;
                                        if (ViewData["Locations"] != null)
                                        {
                                            dt = (DataTable)ViewData["Locations"];

                                            for (int i = 0; i < dt.Rows.Count; i++)
                                            {
                                                <option value="@dt.Rows[i]["LocationId"]">@dt.Rows[i]["LocationName"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="LocationId" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="RoleName" class="control-label"></label>
                                <select asp-for="RoleName" id="RoleName" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt1;
                                        if (ViewData["Roles"] != null)
                                        {
                                            dt1 = (DataTable)ViewData["Roles"];

                                            for (int i = 0; i < dt1.Rows.Count; i++)
                                            {
                                                <option value="@dt1.Rows[i]["Name"]">@dt1.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="RoleName" class="text-danger"></span>
                            </div>

                            <div class="form-group">
                                <label asp-for="FirstName" class="control-label"></label>
                                <input asp-for="FirstName" class="form-control" />
                                <span asp-validation-for="FirstName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LastName" class="control-label"></label>
                                <input asp-for="LastName" class="form-control" />
                                <span asp-validation-for="LastName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Email" class="control-label"></label>
                                <input asp-for="Email" class="form-control" />
                                <span asp-validation-for="Email" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Password" class="control-label"></label>
                                <input asp-for="Password" class="form-control" />
                                <span asp-validation-for="Password" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="ConfirmPassword"></label>
                                <input asp-for="ConfirmPassword" class="form-control" />
                                <span asp-validation-for="ConfirmPassword" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <input type="submit" value="Create Company User" class="btn btn-primary" />
                            </div>
                        </div>
                    </div>
                </form>
                <div class="footer-listing">
                    <a asp-action="Index">Back to List</a>
                </div>
            </div>
        </div>
    </section>
</div>


@section Scripts {
    <partial name="_ValidationScriptsPartial" />
}

ListKong/Views/CompanyUser/Edit.cshtml
@model ListKong.Models.EditCompanyUserModel
@using  System.Data;
@{
    ViewData["Title"] = "Company User";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">

        <ol class="breadcrumb">
            <li><a asp-controller="CompanyUser" asp-action="Index"><i class="fa fa-dashboard"></i><span class="icon-after-span">Manage Company User</span></a></li>
            <li class="active">View Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">

            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="box-title">View Company User</h4>
                </div>
                <form asp-action="Edit" enctype="multipart/form-data" method="post">
                    <div class="panel-body table-responsive">
                        <div class="col-md-6">
                            <div asp-validation-summary="ModelOnly" class="text-danger"></div>

                            <input type="hidden" asp-for="Id" class="form-control" />
                            <div class="form-group">
                                <input type="hidden" asp-for="CompanyId" class="form-control" />
                                <label asp-for="CompanyName" class="control-label"></label>
                                <input asp-for="CompanyName" class="form-control" style="pointer-events:none;" />
                                <span asp-validation-for="CompanyName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LocationId" class="control-label"></label>
                                <select asp-for="LocationId" id="LocationId" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt;
                                        if (ViewData["Locations"] != null)
                                        {
                                            dt = (DataTable)ViewData["Locations"];

                                            for (int i = 0; i < dt.Rows.Count; i++)
                                            {
                                                <option value="@dt.Rows[i]["LocationId"]">@dt.Rows[i]["LocationName"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="LocationId" class="text-danger"></span>
                            </div>

                            <div class="form-group">
                                <label asp-for="RoleName" class="control-label"></label>
                                <select asp-for="RoleName" id="RoleName" class="form-control">
                                    <option value="">-- Choose One --</option>
                                    @{
                                        DataTable dt1;
                                        if (ViewData["Roles"] != null)
                                        {
                                            dt1 = (DataTable)ViewData["Roles"];

                                            for (int i = 0; i < dt1.Rows.Count; i++)
                                            {
                                                <option value="@dt1.Rows[i]["Name"]">@dt1.Rows[i]["Name"]</option>
                                            }
                                        }
                                    }
                                </select>
                                <span asp-validation-for="RoleName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="FirstName" class="control-label"></label>
                                <input asp-for="FirstName" class="form-control" />
                                <span asp-validation-for="FirstName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="LastName" class="control-label"></label>
                                <input asp-for="LastName" class="form-control" />
                                <span asp-validation-for="LastName" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <label asp-for="Email" class="control-label"></label>
                                <input asp-for="Email" class="form-control" style="pointer-events:none;" />
                                <span asp-validation-for="Email" class="text-danger"></span>
                            </div>
                            <div class="form-group">
                                <input type="submit" value="Update Company User" class="btn btn-primary" />
                            </div>
                        </div>
                    </div>
                </form>
                <div class="footer-listing">
                    <a asp-action="Index">Back to List</a>
                </div>
            </div>

        </div>
    </section>
</div>


@section Scripts {
    <partial name="_ValidationScriptsPartial" />
}

ListKong/Views/CompanyUser/Index.cshtml
@model IEnumerable<CompanyUserListModel>

@{
    ViewData["Title"] = "Manage Company User";
}

<div class="container-fluid" style="min-height: 500.8px;margin:0 !important;">
    <section class="content-header">
        
        <ol class="breadcrumb">
            <li><a href="#"><i class="fa fa-dashboard"></i><span class="icon-after-span"> Home</span></a></li>
            <li class="active">Manage Company User</li>
        </ol>
    </section>
    <section class="content">
        <div class="row">
            <div class="col-md-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h4 class="box-title">Manage Company User</h4>
                        <div class="box-tools">
                            <div class="input-group input-group-sm" style="width: 150px;text-align:right;">
                                <a asp-controller="CompanyUser" asp-action="CreateUser"><i class="fa fa-plus-circle"></i><span class="icon-after-span">Add New</span></a>
                            </div>
                        </div>
                    </div>
                    <!-- /.box-header -->
                    <div class="panel-body table-responsive">
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["ErrorMessage"])))
                        {
                            <div class="alert alert-danger">  @TempData["ErrorMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        @if (!string.IsNullOrEmpty(Convert.ToString(TempData["SuccessMessage"])))
                        {
                            <div class="alert alert-success">  @TempData["SuccessMessage"]</div>
                            <script>
                                $(function () {
                                    setTimeout(function () { hideTarget(); }, 5000);
                                });
                                function hideTarget() {
                                    $(".alert").hide();
                                }
                            </script>
                        }
                        <table class="table table-bordered">
                            <thead>
                                <tr>

                                    <th>
                                        @Html.DisplayNameFor(model => model.CompanyName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.LocationName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.RoleName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.FirstName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.LastName)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.Email)
                                    </th>
                                    <th>
                                        @Html.DisplayNameFor(model => model.CreatedOn)
                                    </th>

                                    <th></th>
                                </tr>
                            </thead>
                            <tbody>
                                @foreach (var item in Model)
                                {
                                <tr>

                                    <td>
                                        @Html.DisplayFor(modelItem => item.CompanyName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.LocationName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.RoleName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.FirstName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.LastName)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.Email)
                                    </td>
                                    <td>
                                        @Html.DisplayFor(modelItem => item.CreatedOn)
                                    </td>
                                    <td>
                                        <a asp-action="Edit" asp-route-id="@item.ComLocId" class="fa fa-pencil" title="Edit Company User"></a>
                                        <a asp-action="Delete" asp-route-id="@item.ComLocId" onclick="return confirm('Are sure wants to delete?');" class="fa fa-trash" title="Delete User"></a>
                                    </td>
                                </tr>
                                }
                            </tbody>
                        </table>
                    </div>
                </div>
                <div>
                    @*<a asp-action="Index">Back to List</a>*@
                </div>
                <!-- /.box -->
            </div>
        </div>
    </section>
</div>